/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
	"time"
)

// checks if the MicrosoftAdsStaticUserAuth type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &MicrosoftAdsStaticUserAuth{}

// MicrosoftAdsStaticUserAuth struct for MicrosoftAdsStaticUserAuth
type MicrosoftAdsStaticUserAuth struct {
	Id             NullableInt32 `json:"id,omitempty"`
	CustomerId     *string       `json:"customer_id,omitempty"`
	CreatedAt      NullableInt32 `json:"created_at,omitempty"`
	UpdatedAt      NullableInt32 `json:"updated_at,omitempty"`
	Label          *string       `json:"label,omitempty"`
	ObjectId       *string       `json:"objectId,omitempty"`
	Status         *bool         `json:"status,omitempty"`
	StatusDetail   *string       `json:"status_detail,omitempty"`
	ServiceType    *string       `json:"service_type,omitempty"`
	LastUse        NullableTime  `json:"last_use,omitempty"`
	Identifier     *string       `json:"identifier,omitempty"`
	Hash           *string       `json:"hash,omitempty"`
	Type           *string       `json:"type,omitempty"`
	DeveloperToken *string       `json:"developerToken,omitempty"`
	ClientId       *string       `json:"clientId,omitempty"`
	ClientSecret   *string       `json:"clientSecret,omitempty"`
	RedirectUri    *string       `json:"redirectUri,omitempty"`
	Tenant         *string       `json:"tenant,omitempty"`
}

// NewMicrosoftAdsStaticUserAuth instantiates a new MicrosoftAdsStaticUserAuth object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewMicrosoftAdsStaticUserAuth() *MicrosoftAdsStaticUserAuth {
	this := MicrosoftAdsStaticUserAuth{}
	return &this
}

// NewMicrosoftAdsStaticUserAuthWithDefaults instantiates a new MicrosoftAdsStaticUserAuth object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewMicrosoftAdsStaticUserAuthWithDefaults() *MicrosoftAdsStaticUserAuth {
	this := MicrosoftAdsStaticUserAuth{}
	return &this
}

// GetId returns the Id field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *MicrosoftAdsStaticUserAuth) GetId() int32 {
	if o == nil || IsNil(o.Id.Get()) {
		var ret int32
		return ret
	}
	return *o.Id.Get()
}

// GetIdOk returns a tuple with the Id field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *MicrosoftAdsStaticUserAuth) GetIdOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return o.Id.Get(), o.Id.IsSet()
}

// HasId returns a boolean if a field has been set.
func (o *MicrosoftAdsStaticUserAuth) HasId() bool {
	if o != nil && o.Id.IsSet() {
		return true
	}

	return false
}

// SetId gets a reference to the given NullableInt32 and assigns it to the Id field.
func (o *MicrosoftAdsStaticUserAuth) SetId(v int32) {
	o.Id.Set(&v)
}

// SetIdNil sets the value for Id to be an explicit nil
func (o *MicrosoftAdsStaticUserAuth) SetIdNil() {
	o.Id.Set(nil)
}

// UnsetId ensures that no value is present for Id, not even an explicit nil
func (o *MicrosoftAdsStaticUserAuth) UnsetId() {
	o.Id.Unset()
}

// GetCustomerId returns the CustomerId field value if set, zero value otherwise.
func (o *MicrosoftAdsStaticUserAuth) GetCustomerId() string {
	if o == nil || IsNil(o.CustomerId) {
		var ret string
		return ret
	}
	return *o.CustomerId
}

// GetCustomerIdOk returns a tuple with the CustomerId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MicrosoftAdsStaticUserAuth) GetCustomerIdOk() (*string, bool) {
	if o == nil || IsNil(o.CustomerId) {
		return nil, false
	}
	return o.CustomerId, true
}

// HasCustomerId returns a boolean if a field has been set.
func (o *MicrosoftAdsStaticUserAuth) HasCustomerId() bool {
	if o != nil && !IsNil(o.CustomerId) {
		return true
	}

	return false
}

// SetCustomerId gets a reference to the given string and assigns it to the CustomerId field.
func (o *MicrosoftAdsStaticUserAuth) SetCustomerId(v string) {
	o.CustomerId = &v
}

// GetCreatedAt returns the CreatedAt field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *MicrosoftAdsStaticUserAuth) GetCreatedAt() int32 {
	if o == nil || IsNil(o.CreatedAt.Get()) {
		var ret int32
		return ret
	}
	return *o.CreatedAt.Get()
}

// GetCreatedAtOk returns a tuple with the CreatedAt field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *MicrosoftAdsStaticUserAuth) GetCreatedAtOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return o.CreatedAt.Get(), o.CreatedAt.IsSet()
}

// HasCreatedAt returns a boolean if a field has been set.
func (o *MicrosoftAdsStaticUserAuth) HasCreatedAt() bool {
	if o != nil && o.CreatedAt.IsSet() {
		return true
	}

	return false
}

// SetCreatedAt gets a reference to the given NullableInt32 and assigns it to the CreatedAt field.
func (o *MicrosoftAdsStaticUserAuth) SetCreatedAt(v int32) {
	o.CreatedAt.Set(&v)
}

// SetCreatedAtNil sets the value for CreatedAt to be an explicit nil
func (o *MicrosoftAdsStaticUserAuth) SetCreatedAtNil() {
	o.CreatedAt.Set(nil)
}

// UnsetCreatedAt ensures that no value is present for CreatedAt, not even an explicit nil
func (o *MicrosoftAdsStaticUserAuth) UnsetCreatedAt() {
	o.CreatedAt.Unset()
}

// GetUpdatedAt returns the UpdatedAt field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *MicrosoftAdsStaticUserAuth) GetUpdatedAt() int32 {
	if o == nil || IsNil(o.UpdatedAt.Get()) {
		var ret int32
		return ret
	}
	return *o.UpdatedAt.Get()
}

// GetUpdatedAtOk returns a tuple with the UpdatedAt field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *MicrosoftAdsStaticUserAuth) GetUpdatedAtOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return o.UpdatedAt.Get(), o.UpdatedAt.IsSet()
}

// HasUpdatedAt returns a boolean if a field has been set.
func (o *MicrosoftAdsStaticUserAuth) HasUpdatedAt() bool {
	if o != nil && o.UpdatedAt.IsSet() {
		return true
	}

	return false
}

// SetUpdatedAt gets a reference to the given NullableInt32 and assigns it to the UpdatedAt field.
func (o *MicrosoftAdsStaticUserAuth) SetUpdatedAt(v int32) {
	o.UpdatedAt.Set(&v)
}

// SetUpdatedAtNil sets the value for UpdatedAt to be an explicit nil
func (o *MicrosoftAdsStaticUserAuth) SetUpdatedAtNil() {
	o.UpdatedAt.Set(nil)
}

// UnsetUpdatedAt ensures that no value is present for UpdatedAt, not even an explicit nil
func (o *MicrosoftAdsStaticUserAuth) UnsetUpdatedAt() {
	o.UpdatedAt.Unset()
}

// GetLabel returns the Label field value if set, zero value otherwise.
func (o *MicrosoftAdsStaticUserAuth) GetLabel() string {
	if o == nil || IsNil(o.Label) {
		var ret string
		return ret
	}
	return *o.Label
}

// GetLabelOk returns a tuple with the Label field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MicrosoftAdsStaticUserAuth) GetLabelOk() (*string, bool) {
	if o == nil || IsNil(o.Label) {
		return nil, false
	}
	return o.Label, true
}

// HasLabel returns a boolean if a field has been set.
func (o *MicrosoftAdsStaticUserAuth) HasLabel() bool {
	if o != nil && !IsNil(o.Label) {
		return true
	}

	return false
}

// SetLabel gets a reference to the given string and assigns it to the Label field.
func (o *MicrosoftAdsStaticUserAuth) SetLabel(v string) {
	o.Label = &v
}

// GetObjectId returns the ObjectId field value if set, zero value otherwise.
func (o *MicrosoftAdsStaticUserAuth) GetObjectId() string {
	if o == nil || IsNil(o.ObjectId) {
		var ret string
		return ret
	}
	return *o.ObjectId
}

// GetObjectIdOk returns a tuple with the ObjectId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MicrosoftAdsStaticUserAuth) GetObjectIdOk() (*string, bool) {
	if o == nil || IsNil(o.ObjectId) {
		return nil, false
	}
	return o.ObjectId, true
}

// HasObjectId returns a boolean if a field has been set.
func (o *MicrosoftAdsStaticUserAuth) HasObjectId() bool {
	if o != nil && !IsNil(o.ObjectId) {
		return true
	}

	return false
}

// SetObjectId gets a reference to the given string and assigns it to the ObjectId field.
func (o *MicrosoftAdsStaticUserAuth) SetObjectId(v string) {
	o.ObjectId = &v
}

// GetStatus returns the Status field value if set, zero value otherwise.
func (o *MicrosoftAdsStaticUserAuth) GetStatus() bool {
	if o == nil || IsNil(o.Status) {
		var ret bool
		return ret
	}
	return *o.Status
}

// GetStatusOk returns a tuple with the Status field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MicrosoftAdsStaticUserAuth) GetStatusOk() (*bool, bool) {
	if o == nil || IsNil(o.Status) {
		return nil, false
	}
	return o.Status, true
}

// HasStatus returns a boolean if a field has been set.
func (o *MicrosoftAdsStaticUserAuth) HasStatus() bool {
	if o != nil && !IsNil(o.Status) {
		return true
	}

	return false
}

// SetStatus gets a reference to the given bool and assigns it to the Status field.
func (o *MicrosoftAdsStaticUserAuth) SetStatus(v bool) {
	o.Status = &v
}

// GetStatusDetail returns the StatusDetail field value if set, zero value otherwise.
func (o *MicrosoftAdsStaticUserAuth) GetStatusDetail() string {
	if o == nil || IsNil(o.StatusDetail) {
		var ret string
		return ret
	}
	return *o.StatusDetail
}

// GetStatusDetailOk returns a tuple with the StatusDetail field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MicrosoftAdsStaticUserAuth) GetStatusDetailOk() (*string, bool) {
	if o == nil || IsNil(o.StatusDetail) {
		return nil, false
	}
	return o.StatusDetail, true
}

// HasStatusDetail returns a boolean if a field has been set.
func (o *MicrosoftAdsStaticUserAuth) HasStatusDetail() bool {
	if o != nil && !IsNil(o.StatusDetail) {
		return true
	}

	return false
}

// SetStatusDetail gets a reference to the given string and assigns it to the StatusDetail field.
func (o *MicrosoftAdsStaticUserAuth) SetStatusDetail(v string) {
	o.StatusDetail = &v
}

// GetServiceType returns the ServiceType field value if set, zero value otherwise.
func (o *MicrosoftAdsStaticUserAuth) GetServiceType() string {
	if o == nil || IsNil(o.ServiceType) {
		var ret string
		return ret
	}
	return *o.ServiceType
}

// GetServiceTypeOk returns a tuple with the ServiceType field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MicrosoftAdsStaticUserAuth) GetServiceTypeOk() (*string, bool) {
	if o == nil || IsNil(o.ServiceType) {
		return nil, false
	}
	return o.ServiceType, true
}

// HasServiceType returns a boolean if a field has been set.
func (o *MicrosoftAdsStaticUserAuth) HasServiceType() bool {
	if o != nil && !IsNil(o.ServiceType) {
		return true
	}

	return false
}

// SetServiceType gets a reference to the given string and assigns it to the ServiceType field.
func (o *MicrosoftAdsStaticUserAuth) SetServiceType(v string) {
	o.ServiceType = &v
}

// GetLastUse returns the LastUse field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *MicrosoftAdsStaticUserAuth) GetLastUse() time.Time {
	if o == nil || IsNil(o.LastUse.Get()) {
		var ret time.Time
		return ret
	}
	return *o.LastUse.Get()
}

// GetLastUseOk returns a tuple with the LastUse field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *MicrosoftAdsStaticUserAuth) GetLastUseOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return o.LastUse.Get(), o.LastUse.IsSet()
}

// HasLastUse returns a boolean if a field has been set.
func (o *MicrosoftAdsStaticUserAuth) HasLastUse() bool {
	if o != nil && o.LastUse.IsSet() {
		return true
	}

	return false
}

// SetLastUse gets a reference to the given NullableTime and assigns it to the LastUse field.
func (o *MicrosoftAdsStaticUserAuth) SetLastUse(v time.Time) {
	o.LastUse.Set(&v)
}

// SetLastUseNil sets the value for LastUse to be an explicit nil
func (o *MicrosoftAdsStaticUserAuth) SetLastUseNil() {
	o.LastUse.Set(nil)
}

// UnsetLastUse ensures that no value is present for LastUse, not even an explicit nil
func (o *MicrosoftAdsStaticUserAuth) UnsetLastUse() {
	o.LastUse.Unset()
}

// GetIdentifier returns the Identifier field value if set, zero value otherwise.
func (o *MicrosoftAdsStaticUserAuth) GetIdentifier() string {
	if o == nil || IsNil(o.Identifier) {
		var ret string
		return ret
	}
	return *o.Identifier
}

// GetIdentifierOk returns a tuple with the Identifier field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MicrosoftAdsStaticUserAuth) GetIdentifierOk() (*string, bool) {
	if o == nil || IsNil(o.Identifier) {
		return nil, false
	}
	return o.Identifier, true
}

// HasIdentifier returns a boolean if a field has been set.
func (o *MicrosoftAdsStaticUserAuth) HasIdentifier() bool {
	if o != nil && !IsNil(o.Identifier) {
		return true
	}

	return false
}

// SetIdentifier gets a reference to the given string and assigns it to the Identifier field.
func (o *MicrosoftAdsStaticUserAuth) SetIdentifier(v string) {
	o.Identifier = &v
}

// GetHash returns the Hash field value if set, zero value otherwise.
func (o *MicrosoftAdsStaticUserAuth) GetHash() string {
	if o == nil || IsNil(o.Hash) {
		var ret string
		return ret
	}
	return *o.Hash
}

// GetHashOk returns a tuple with the Hash field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MicrosoftAdsStaticUserAuth) GetHashOk() (*string, bool) {
	if o == nil || IsNil(o.Hash) {
		return nil, false
	}
	return o.Hash, true
}

// HasHash returns a boolean if a field has been set.
func (o *MicrosoftAdsStaticUserAuth) HasHash() bool {
	if o != nil && !IsNil(o.Hash) {
		return true
	}

	return false
}

// SetHash gets a reference to the given string and assigns it to the Hash field.
func (o *MicrosoftAdsStaticUserAuth) SetHash(v string) {
	o.Hash = &v
}

// GetType returns the Type field value if set, zero value otherwise.
func (o *MicrosoftAdsStaticUserAuth) GetType() string {
	if o == nil || IsNil(o.Type) {
		var ret string
		return ret
	}
	return *o.Type
}

// GetTypeOk returns a tuple with the Type field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MicrosoftAdsStaticUserAuth) GetTypeOk() (*string, bool) {
	if o == nil || IsNil(o.Type) {
		return nil, false
	}
	return o.Type, true
}

// HasType returns a boolean if a field has been set.
func (o *MicrosoftAdsStaticUserAuth) HasType() bool {
	if o != nil && !IsNil(o.Type) {
		return true
	}

	return false
}

// SetType gets a reference to the given string and assigns it to the Type field.
func (o *MicrosoftAdsStaticUserAuth) SetType(v string) {
	o.Type = &v
}

// GetDeveloperToken returns the DeveloperToken field value if set, zero value otherwise.
func (o *MicrosoftAdsStaticUserAuth) GetDeveloperToken() string {
	if o == nil || IsNil(o.DeveloperToken) {
		var ret string
		return ret
	}
	return *o.DeveloperToken
}

// GetDeveloperTokenOk returns a tuple with the DeveloperToken field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MicrosoftAdsStaticUserAuth) GetDeveloperTokenOk() (*string, bool) {
	if o == nil || IsNil(o.DeveloperToken) {
		return nil, false
	}
	return o.DeveloperToken, true
}

// HasDeveloperToken returns a boolean if a field has been set.
func (o *MicrosoftAdsStaticUserAuth) HasDeveloperToken() bool {
	if o != nil && !IsNil(o.DeveloperToken) {
		return true
	}

	return false
}

// SetDeveloperToken gets a reference to the given string and assigns it to the DeveloperToken field.
func (o *MicrosoftAdsStaticUserAuth) SetDeveloperToken(v string) {
	o.DeveloperToken = &v
}

// GetClientId returns the ClientId field value if set, zero value otherwise.
func (o *MicrosoftAdsStaticUserAuth) GetClientId() string {
	if o == nil || IsNil(o.ClientId) {
		var ret string
		return ret
	}
	return *o.ClientId
}

// GetClientIdOk returns a tuple with the ClientId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MicrosoftAdsStaticUserAuth) GetClientIdOk() (*string, bool) {
	if o == nil || IsNil(o.ClientId) {
		return nil, false
	}
	return o.ClientId, true
}

// HasClientId returns a boolean if a field has been set.
func (o *MicrosoftAdsStaticUserAuth) HasClientId() bool {
	if o != nil && !IsNil(o.ClientId) {
		return true
	}

	return false
}

// SetClientId gets a reference to the given string and assigns it to the ClientId field.
func (o *MicrosoftAdsStaticUserAuth) SetClientId(v string) {
	o.ClientId = &v
}

// GetClientSecret returns the ClientSecret field value if set, zero value otherwise.
func (o *MicrosoftAdsStaticUserAuth) GetClientSecret() string {
	if o == nil || IsNil(o.ClientSecret) {
		var ret string
		return ret
	}
	return *o.ClientSecret
}

// GetClientSecretOk returns a tuple with the ClientSecret field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MicrosoftAdsStaticUserAuth) GetClientSecretOk() (*string, bool) {
	if o == nil || IsNil(o.ClientSecret) {
		return nil, false
	}
	return o.ClientSecret, true
}

// HasClientSecret returns a boolean if a field has been set.
func (o *MicrosoftAdsStaticUserAuth) HasClientSecret() bool {
	if o != nil && !IsNil(o.ClientSecret) {
		return true
	}

	return false
}

// SetClientSecret gets a reference to the given string and assigns it to the ClientSecret field.
func (o *MicrosoftAdsStaticUserAuth) SetClientSecret(v string) {
	o.ClientSecret = &v
}

// GetRedirectUri returns the RedirectUri field value if set, zero value otherwise.
func (o *MicrosoftAdsStaticUserAuth) GetRedirectUri() string {
	if o == nil || IsNil(o.RedirectUri) {
		var ret string
		return ret
	}
	return *o.RedirectUri
}

// GetRedirectUriOk returns a tuple with the RedirectUri field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MicrosoftAdsStaticUserAuth) GetRedirectUriOk() (*string, bool) {
	if o == nil || IsNil(o.RedirectUri) {
		return nil, false
	}
	return o.RedirectUri, true
}

// HasRedirectUri returns a boolean if a field has been set.
func (o *MicrosoftAdsStaticUserAuth) HasRedirectUri() bool {
	if o != nil && !IsNil(o.RedirectUri) {
		return true
	}

	return false
}

// SetRedirectUri gets a reference to the given string and assigns it to the RedirectUri field.
func (o *MicrosoftAdsStaticUserAuth) SetRedirectUri(v string) {
	o.RedirectUri = &v
}

// GetTenant returns the Tenant field value if set, zero value otherwise.
func (o *MicrosoftAdsStaticUserAuth) GetTenant() string {
	if o == nil || IsNil(o.Tenant) {
		var ret string
		return ret
	}
	return *o.Tenant
}

// GetTenantOk returns a tuple with the Tenant field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MicrosoftAdsStaticUserAuth) GetTenantOk() (*string, bool) {
	if o == nil || IsNil(o.Tenant) {
		return nil, false
	}
	return o.Tenant, true
}

// HasTenant returns a boolean if a field has been set.
func (o *MicrosoftAdsStaticUserAuth) HasTenant() bool {
	if o != nil && !IsNil(o.Tenant) {
		return true
	}

	return false
}

// SetTenant gets a reference to the given string and assigns it to the Tenant field.
func (o *MicrosoftAdsStaticUserAuth) SetTenant(v string) {
	o.Tenant = &v
}

func (o MicrosoftAdsStaticUserAuth) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o MicrosoftAdsStaticUserAuth) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if o.Id.IsSet() {
		toSerialize["id"] = o.Id.Get()
	}
	if !IsNil(o.CustomerId) {
		toSerialize["customer_id"] = o.CustomerId
	}
	if o.CreatedAt.IsSet() {
		toSerialize["created_at"] = o.CreatedAt.Get()
	}
	if o.UpdatedAt.IsSet() {
		toSerialize["updated_at"] = o.UpdatedAt.Get()
	}
	if !IsNil(o.Label) {
		toSerialize["label"] = o.Label
	}
	if !IsNil(o.ObjectId) {
		toSerialize["objectId"] = o.ObjectId
	}
	if !IsNil(o.Status) {
		toSerialize["status"] = o.Status
	}
	if !IsNil(o.StatusDetail) {
		toSerialize["status_detail"] = o.StatusDetail
	}
	if !IsNil(o.ServiceType) {
		toSerialize["service_type"] = o.ServiceType
	}
	if o.LastUse.IsSet() {
		toSerialize["last_use"] = o.LastUse.Get()
	}
	if !IsNil(o.Identifier) {
		toSerialize["identifier"] = o.Identifier
	}
	if !IsNil(o.Hash) {
		toSerialize["hash"] = o.Hash
	}
	if !IsNil(o.Type) {
		toSerialize["type"] = o.Type
	}
	if !IsNil(o.DeveloperToken) {
		toSerialize["developerToken"] = o.DeveloperToken
	}
	if !IsNil(o.ClientId) {
		toSerialize["clientId"] = o.ClientId
	}
	if !IsNil(o.ClientSecret) {
		toSerialize["clientSecret"] = o.ClientSecret
	}
	if !IsNil(o.RedirectUri) {
		toSerialize["redirectUri"] = o.RedirectUri
	}
	if !IsNil(o.Tenant) {
		toSerialize["tenant"] = o.Tenant
	}
	return toSerialize, nil
}

type NullableMicrosoftAdsStaticUserAuth struct {
	value *MicrosoftAdsStaticUserAuth
	isSet bool
}

func (v NullableMicrosoftAdsStaticUserAuth) Get() *MicrosoftAdsStaticUserAuth {
	return v.value
}

func (v *NullableMicrosoftAdsStaticUserAuth) Set(val *MicrosoftAdsStaticUserAuth) {
	v.value = val
	v.isSet = true
}

func (v NullableMicrosoftAdsStaticUserAuth) IsSet() bool {
	return v.isSet
}

func (v *NullableMicrosoftAdsStaticUserAuth) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableMicrosoftAdsStaticUserAuth(val *MicrosoftAdsStaticUserAuth) *NullableMicrosoftAdsStaticUserAuth {
	return &NullableMicrosoftAdsStaticUserAuth{value: val, isSet: true}
}

func (v NullableMicrosoftAdsStaticUserAuth) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableMicrosoftAdsStaticUserAuth) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
